#Logstash


This charm provides [LogStash](http://logstash.net). logstash is a tool for managing events and logs. You can use it to collect logs, parse them, and store them for later use (like, for searching)

### Supported  I/O

Inputs :
  File  -  /var/log/syslog and some others
  Redis -  configured to use redis as a message bus from logstash agents
Outputs :
  embedded - embedded elasticsearch ...  this is fine for starting off testing,  but should really use a real cluster
  elasticsearch - creation relationship with elasticsearch charm



# Usage


example 1 - Just the Indexer + Kibana
=====================================

    juju deploy cs:trusty/logstash
    juju deploy cs:precise/kibana
    juju add-relation kibana logstash
    juju expose kibana

http://ip-of-kibana

example 2 - Indexer + 2 x ElasticSearch + Kibana
============================================

    juju deploy cs:trusty/elasticsearch
    juju add-unit elasticsearch
    juju deploy cs:trusty/logstash
    juju add-relation logstash elasticsearch
    juju deploy cs:trusty/kibana
    juju add-relation kibana elasticsearch:rest
    juju expose kibana

http://ip-of-kibana

example 3  - Agent + Indexer + 2 x ElasticSearch + Kibana
=============================================

    juju deploy cs:trusty/elasticsearch
    juju add-unit elasticsearch
    juju deploy cs:trusty/logstash-indexer
    juju add-relation elasticsearch:cluster logstash-indexer
    juju deploy --repository=logstash local:precise/kibana
    juju add-relation elasticsearch:rest kibana
    juju expose kibana
    juju deploy --repository=logstash local:precise/logstash-agent
    juju add-relation logstash-agent logstash-indexer:input



### Caveats

The charm will fetch the logstash complete archive every time. 

The charm has not been tested for scale and clustering, as each unit installs a stand-alone redis-daemon, it should be treated as a stand alone instance. This is inhereted behavior from the precise Logstash charm.

# Configuration

The charm supports installation from anywhere that python requeusts can reach and understand. By default it will install a recent revision (1.4.2 as of this writing) from the elasticsearch.org site. this is configurable with 2 options

    juju set logstash logstash-source="https://download.elasticsearch.org/logstash/logstash/logstash-1.4.2.tar.gz" logstash-sum="d59ef579c7614c5df9bd69cfdce20ed371f728ff"

There is also a configuration option to add arbitrary packages pre-installation of logstash. The format is a space separated list.

    juju set logstash extrapackages='vim byobu'

# Contact Information

- Upstream website: [logstash.net](http://logstash.net)
- Upstream bug tracker: [Logstash Jira](http://logstash.jira.com/)

